module.exports.taskSpecOptionsSchema = {
    type: 'object',
    strict: true,
    properties: {
        taskName: {type: 'string'},
        prodMode: {type: ['boolean', 'function']},
        baseSrc: {type: 'string', optional: true},
        baseSrcDev: {type: 'string', optional: true},
        baseSrcProd: {type: 'string', optional: true},
        src: {type: 'array', items: {type: 'string'}, optional: true},
        srcDev: {type: 'array', items: {type: 'string'}, optional: true},
        srcProd: {type: 'array', items: {type: 'string'}, optional: true},
        watchSrc: {type: 'array', items: {type: 'string'}, optional: true},
        watchSrcDev: {type: 'array', items: {type: 'string'}, optional: true},
        watchSrcProd: {type: 'array', items: {type: 'string'}, optional: true},
        baseDest: {type: 'string', optional: true},
        baseDestDev: {type: 'string', optional: true},
        baseDestProd: {type: 'string', optional: true},
        dest: {type: 'string', optional: true},
        destDev: {type: 'string', optional: true},
        destProd: {type: 'string', optional: true},
        output: {type: 'array', items: {type: 'string'}, optional: true},
        outputDev: {type: 'array', items: {type: 'string'}, optional: true},
        outputProd: {type: 'array', items: {type: 'string'}, optional: true},
        sharedProcessor: {type: 'function'},
        devProcessor: {type: 'function'},
        prodProcessor: {type: 'function'},
        registerWatcher: {type: 'boolean'},
        createCleanTask: {type: 'boolean'},
        runTasksOnChange: {type: 'array', items: {type: 'string'}},
        runTasksBefore: {type: 'array', items: {type: 'string'}},
        liveReload: {type: 'boolean'},
        verbose: {type: 'boolean'}
    }
};

module.exports.taskSpecOptionsSanitizeSchema = {
    type: 'object',
    properties: {
        prodMode: {def: false, optional: false},
        src: {type: 'array'},
        srcDev: {type: 'array'},
        srcProd: {type: 'array'},
        watchSrc: {type: 'array'},
        watchSrcDev: {type: 'array'},
        watchSrcProd: {type: 'array'},
        output: {type: 'array'},
        outputDev: {type: 'array'},
        outputProd: {type: 'array'},
        sharedProcessor: {def: identity, optional: false},
        devProcessor: {def: identity, optional: false},
        prodProcessor: {def: identity, optional: false},
        registerWatcher: {def: true, optional: false},
        createCleanTask: {def: true, optional: false},
        runTasksOnChange: {type: 'array', def: [], optional: false},
        runTasksBefore: {type: 'array', def: [], optional: false},
        liveReload: {def: false, optional: false},
        verbose: {def: false, optional: false}
    }
};


function identity(idn) { return idn; }